/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.s4s.dao.impl;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import org.s4s.exceptions.DAOException;
import org.s4s.exceptions.NoSuchProduct;
import org.s4s.dao.ProductDAO;
import org.s4s.modell.dto.Product;
import org.s4s.services.db.JDBCConnection;

/**
 *
 * @author Holger
 */
public class ProductSearch extends AbstractDatabaseClass implements ProductDAO {

//    Product p1 = new Product("Nachhilfe Algebra", 1, "Nachhilfe", 2.00, "Biete Nachhilfe in Algebra an!");
//    Product p2 = new Product("F&I", 2, "Mitschriften", 5.00, "Mitschriften aus dem WS16/17 in F&I!");
//    Product p3 = new Product("Übungen Eidip", 3, "Lösungen", 10.50, "Lösungen zu alten Eidip Aufgaben!");

    private ProductSearch() {

    }

    public static ProductSearch search = null;

    public static ProductSearch getInstance() {
        if (search == null) {
            search = new ProductSearch();
        }
        return search;
    }

    @Override
    public List<Product> getProductByTyp(String kateg) throws DAOException {
        List<Product> liste = new ArrayList<>();
        try(  ResultSet set = executeQuery("SELECT *"
                    + " FROM \"ERR\".\"artikel\" a"
                    + " WHERE LOWER(a.kategorie) = LOWER('" + kateg + "');")) {
             while(set.next()) {
                String name = set.getString("name");
                int id = set.getInt("artikelID");
                String kategorie = set.getString("kategorie");
                double price = set.getDouble("preis");
                String description = set.getString("beschreibung");
                
                Product p = new Product(name, id, kategorie, price, description);
                liste.add(p);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return liste;
    }

    @Override
    public List<Product> getProductByDescription(String descrip) throws DAOException {
        List<Product> liste = new ArrayList<>();
        try(ResultSet set = executeQuery("SELECT *"
                    + " FROM \"ERR\".\"artikel\" a"
                    + " WHERE LOWER(a.beschreibung) ILIKE LOWER('%" + descrip + "%');")) {
            while(set.next()) {
                String name = set.getString("name");
                int id = set.getInt("artikelID");
                String kategorie = set.getString("kategorie");
                double price = set.getDouble("preis");
                String description = set.getString("beschreibung");
                
                Product p = new Product(name, id, kategorie, price, description);
                liste.add(p);
            }
        } catch (SQLException ex) {
            throw new DAOException(ex);
        }
        return liste;
    }
}
