/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.s4s.dao.impl;

import com.vaadin.server.VaadinSession;
import com.vaadin.ui.UI;
import java.sql.SQLException;
import org.s4s.dao.ShopDAO;
import org.s4s.services.util.Roles;
import org.s4s.exceptions.OwnsAlreadyShop;
import org.s4s.modell.dto.User;
import org.s4s.services.util.Views;

/**
 *
 * @author Benjamin
 */
public class ShopControl {
    private static final User user = (User) VaadinSession.getCurrent().getAttribute(Roles.CURRENTUSER);

    //bekommt User aus der View übergeben und prüft ob dieser schon in der Shopdb vorhanden ist (= hat schon einen Shop).
    public static void checkUserShop( String shopName, String shopBeschreibung) throws OwnsAlreadyShop, SQLException {
        boolean test = ShopDAO.getInstance().viewShop(user);
        //Shop mit dem Nutzer schon vorhanden
        if (test == false) {
            throw new OwnsAlreadyShop("Sie besitzen bereits einen Shop!");
        } //noch kein Shop vorhanden 
        else {
           addUserShop(shopName, shopBeschreibung);
        }
    }

    private static void addUserShop(String shopName, String shopBeschreibung) throws SQLException {
        boolean erstellung = ShopDAO.getInstance().addShop(user, shopName, shopBeschreibung);
           
        if (erstellung == true){
            //Weiterleitung zur Shopseite, wenn Shop erfolgreich erstellt
                 UI.getCurrent().getNavigator().navigateTo(Views.SHOP);
        } else {
              //Fehlerhandling 
              throw new SQLException("Fehler beim Anlegen des Shops bitte noch einmal versuchen oder Programmierer kontaktieren!");
        }
    }
}
