/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.s4s.gui.views;

import com.vaadin.data.util.BeanContainer;
import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.server.FontAwesome;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Table;
import com.vaadin.ui.TextField;
import java.util.HashSet;
import java.util.Set;
import org.s4s.exceptions.DAOException;
import org.s4s.exceptions.NoSuchProduct;
import org.s4s.dao.ProductDAO;
import org.s4s.dao.impl.ProductSearch;
import org.s4s.modell.dto.Product;

/**
 *
 * @author Holger
 */
public class ShopView extends TemplateView {

    private final ProductDAO products = ProductSearch.getInstance();

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        this.setUp();
    }

    public void setUp() {
        //   setSizeFull();
        setMargin(true);

        final HorizontalLayout searchLayout = new HorizontalLayout();
        final HorizontalLayout buttonLayout = new HorizontalLayout();

        TextField textfield = new TextField();
        Button button = new Button("Suche", FontAwesome.SEARCH);
        Label label = new Label("Das erste Label unseres Shop in Shop System");

        buttonLayout.addComponent(label);
        buttonLayout.setComponentAlignment(label, Alignment.TOP_LEFT);

        searchLayout.addComponent(textfield);
        searchLayout.addComponent(button);
        buttonLayout.addComponent(searchLayout);
        buttonLayout.setComponentAlignment(searchLayout, Alignment.TOP_RIGHT);
        buttonLayout.setSizeFull();
        addComponent(buttonLayout);
        //setComponentAlignment(buttonLayout, Alignment.TOP_CENTER);

        final BeanContainer<Integer, Product> data = new BeanContainer<>(Product.class);
        data.setBeanIdProperty("id");
        final Table table = new Table("Products", data);
        table.setSizeFull();
        table.setSelectable(true);

        button.addClickListener((Button.ClickEvent event) -> {
            String str = textfield.getValue().trim();

            if (str.equals("")) {
                Notification.show(null, "Bitte gesuchtes Produkt eingeben!", Notification.Type.WARNING_MESSAGE);
            } else {
                addComponent(table);

                Set<Product> liste = new HashSet<>();
                try {
                    liste.addAll(products.getProductByTyp(str));
                    liste.addAll(products.getProductByDescription(str));
                } catch (DAOException ex) {

                }
               
                
                data.removeAllItems();
                data.addAll(liste);
                table.setPageLength(table.size());
            }
        });
    }
}
