/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.s4s.modell.dto;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Holger
 */
public class Warenkorb {

    private final List<Product> products;

    public Warenkorb() {
        products = new ArrayList<>();
    }

    public void add(Product p) {
        if (p == null) {
            throw new NullPointerException("Produkt darf nicht null sein!");
        }
        products.add(p);
    }

    public void remove(Product p) {
        if (p == null) {
            throw new NullPointerException("Produkt darf nicht null sein!");
        }
        if (!products.contains(p)) {
            throw new IllegalArgumentException("Das Produkt ist nicht im Warenkorb enthalten!");
        }
        products.remove(p);
    }

    public double sum() {
        return products.stream().mapToDouble(p -> p.getPrice()).sum();
    }

    public boolean contains(Product p) {
        if (p == null) {
            throw new NullPointerException("Produkt darf nicht null sein!");
        }
        return products.contains(p);
    }

    public int getAnzahl() {
        return products.size();
    }
}
